// #autoload
// #name = TeamTV
// #version = 1.2
// #date = February 2nd, 2002
// #author = <spush><color:ffff00></a><a:tribe	The Ministry>min <color:ffffff><a:player	TruSoulja>TruSoulja</a><spop>
// #warrior = TruSoulja
// #email = trusoulja@zbzoom.net
// #ICQ = 11108946
// #web = http://www.t2-ministry.com/
// #description = At the press of the key you will be able to observe teammates in fullscreen
// #status = Release
// #readme = scripts/autoexec/trusoulja/readme.txt

//-----create the TeamTV Huds
function createTeamTVHud() {
  new GuiControlProfile (TeamTVTextProfile) {
    fontType = "Arial";
    fontSize = 16;
    fontColor = "255 255 255";
    justify = "center";
  };

  if (!isObject(TeamTV)) {
    new GuiControl(TeamTV) {
      horizSizing = "center";
      vertSizing = "top";
      position = "0 0";
      extent = "100 100";
      minExtent = "16 18";
      visible = "0";
      helpTag = "0";

      new ShellFieldCtrl(TeamTVCommanderMap) {
        profile = "GuiChatBackProfile";
        horizSizing = "center";
        vertSizing = "top";
        position = "0 0";
        extent = "100 100";
        minExtent = "10 10";
        visible = "0";
        helpTag = "0";
      };

      new ShellFieldCtrl(TeamTVObsHud) {
      	profile = "GuiChatBackProfile";
      	horizSizing = "center";
      	vertSizing = "top";
      	position = "0 0";
      	extent = "300 25";
      	minExtent = "16 18";
      	visible = "1";
      	helpTag = "0";

      	new GuiMLTextCtrl(TeamTVObsHudText) {
      		profile = "TeamTVTextProfile";
      		horizSizing = "center";
      		vertSizing = "top";
      		position = "5 4";
      		extent = "290 20";
      		minExtent = "8 8";
      		visible = "1";
      		helpTag = "0";
      		lineSpacing = "2";
      		allowColorChars = 1;
      		maxChars = "-1";
      	};
      };

      new ShellFieldCtrl(TeamTVSelHud) {
      	profile = "GuiChatBackProfile";
      	horizSizing = "center";
      	vertSizing = "top";
      	position = "0 0";
      	extent = "100 100";
      	minExtent = "16 18";
      	visible = "0";
      	helpTag = "0";
      };
    };
  }

	if(isObject(HM) && isObject(HudMover)) {
		HudMover::addHud(TeamTVObsHud, "Team TV Observer Name Hud");
		HudMover::addHud(TeamTVSelHud, "Team TV Selector Hud");
  }

  // create some bindings
  new ActionMap(TeamTVActMap);
  TeamTVActMap.bind(mouse0, "button0", observeNext);
  TeamTVActMap.bind(mouse0, "button1", observePrev);

  // set up some defaults
  TeamTV.targetToNamePtrCt = 0;
  TeamTV.mapRefreshed = false;
  TeamTV.optionsBind = false;
  TeamTV.resetEngHud = false;
  TeamTV.defaultSelHeight = 250;
  TeamTV.defaultHeaderHeight = 20;
  TeamTV.defaultEntryHeight = 20;
  TeamTV.defaultBackdropBitmap = "commander/gui/cmd_gradient";
  TeamTV.defaultEntrySelectColor = "44 168 219 100";
  TeamTV.defaultEntryHilightColor = "44 168 219 100";
  TeamTV.defaultClientNoneText = "None Selected";
}

function findCurrTarget() {
  %count = CommanderTree.getNumTargets("Clients");
  for (%i = 0; %i < %count; %i++) {
    %currTarget = CommanderTree.getTarget("Clients", %i);
    if (%currTarget == TeamTV.obsTarget)
      return %i;
  }
}

//-----observe the next person in line
function observeNext(%val) {
  if (%val) {
    %count = CommanderTree.getNumTargets("Clients");
    %loc = findCurrTarget();
    if (%loc >= %count - 1)
      %loc = -1;
    TeamTV.obsTarget = CommanderTree.getTarget("Clients", %loc + 1);
    TeamTV.obsName = TeamTV.targetToName[TeamTV.obsTarget];
    if (TeamTV.obsName $= "")
      TeamTV.obsName = "<spush><color:ff0000>Name has not been initialized<spop>";
    TeamTV.obsType = "_ClientConnection";
    TeamTV.openCamera(1);
  }
}

//-----observe the previous person in line
function observePrev(%val) {
  if (%val) {
    %count = CommanderTree.getNumTargets("Clients");
    %loc = findCurrTarget();
    if (%loc == 0)
      %loc = %count;
    TeamTV.obsTarget = CommanderTree.getTarget("Clients", %loc - 1);
    TeamTV.obsName = TeamTV.targetToName[TeamTV.obsTarget];
    if (TeamTV.obsName $= "")
      TeamTV.obsName = "<spush><color:ff0000>Name has not been initialized<spop>";
    TeamTV.obsType = "_ClientConnection";
    TeamTV.openCamera(1);
  }
}

//-----toggle teamtv hud
function TeamTVtoggle(%val) {
  if (%val)
    if (TeamTV.isOpen)
      TeamTV.open(0);
    else
      TeamTV.open(1);
}

//-----toggle teamtv hud
function TeamTVtoggleSelector(%val) {
  if (%val)
    if (TeamTV.isOpen && TeamTV.mapRefreshed && TeamTV.followType == 0)
      if (TeamTVSelHud.visible) {
        TeamTVSelHud.setVisible(0);
        cursorOff();
      } else {
        TeamTVSelHud.setVisible(1);
        cursorOn();
      }
}

//-----refresh commandermap
function refreshMap() {
  CommanderMapGui.remove(CommanderMap);
  TeamTVCommanderMap.add(CommanderMap);
  TeamTVCommanderMap.remove(CommanderMap);
  CommanderMapGui.add(CommanderMap);
  CommanderMapGui.bringToFront(CommanderMap);
  TeamTV.mapRefreshed = true;
}

//-----reset camera to static
function resetTeamTV() {
  if (TeamTV.isOpen)
    TeamTV.open(0);
  TeamTV.obsTarget = -1;
  TeamTV.obsName = "";
  TeamTV.obsType = "";

  // reset pointer arrays
  for (%i = 0; %i < TeamTV.targetToNamePtrCt; %i++) {
    TeamTV.targetToName[TeamTV.targetToNamePtr[%i]] = "";
    TeamTV.targetToNamePtr[%i] = "";
  }
  TeamTV.targetToNamePtrCt = 0;
}

//-----check to see if selected target is a valid target
function TeamTV::isTarget(%this) {
  if (%this.obsTarget <= -1)
    return false;
  else if (%this.obsType !$= "_ClientConnection")
    return false;
  return true;
}

//-----close categories and save information
function TeamTV::editCategories(%this, %val) {
  if (%val) {
    %this.CMDPlayers = CMDPlayersButton.getValue();
    %this.CMDTactical = CMDTacticalButton.getValue();
    %this.CMDDTactical = CMDDeployedTacticalButton.getValue();
    %this.CMDSupport = CMDMiscButton.getValue();
    %this.CMDDSupport = CMDDeployedMiscButton.getValue();
    %this.CMDWaypoints = CMDWaypointsButton.getValue();
    %this.CMDObjectives = CMDObjectivesButton.getValue();
    CommanderTree.openCategory("Clients", 1);
    CommanderTree.openCategory("Tactical", 0);
    CommanderTree.openCategory("DTactical", 0);
    CommanderTree.openCategory("Support", 0);
    CommanderTree.openCategory("DSupport", 0);
    CommanderTree.openCategory("Waypoints", 0);
    CommanderTree.openCategory("Objectives", 0);
  } else {
    CommanderTree.openCategory("Clients", %this.CMDPlayers);
    CommanderTree.openCategory("Tactical", %this.CMDTactical);
    CommanderTree.openCategory("DTactical", %this.CMDDTactical);
    CommanderTree.openCategory("Support", %this.CMDSupport);
    CommanderTree.openCategory("DSupport", %this.CMDDSupport);
    CommanderTree.openCategory("Waypoints", %this.CMDWaypoints);
    CommanderTree.openCategory("Objectives", %this.CMDObjectives);
  }
}

//-----save old attributes so they can be restored
function TeamTV::editAttr(%this, %val) {
  if (%val) {         // this means we want to save and change for new
    // save visibilities
    %this.oldCommanderTreeContainerVisible = CommanderTreeContainer.visible;
    %this.oldCommanderTreeVisible = CommanderTree.visible;
    %this.oldVisible = CommanderTV.visible;

    // save extents
    %this.oldCommanderTreeContainerExtent = CommanderTreeContainer.extent;
    %this.oldCommanderTreeExtent = CommanderTree.extent;
    %this.oldCommanderTVExtent = CommanderTV.extent;

    // save positions
    %this.oldCommanderTreeContainerPos = CommanderTreeContainer.position;
    %this.oldCommanderTreePos = CommanderTree.position;
    %this.oldCommanderTVPos = CommanderTV.position;
  } else {            // this means we want to restore and change back to old
    // visibilities
    CommanderTreeContainer.setVisible(%this.oldCommanderTreeContainerVisible);
    CommanderTree.setVisible(%this.oldCommanderTreeVisible);
    CommanderTV.setVisible(%this.oldCommanderTVVisible);

    // extents
    CommanderTreeContainer.extent = %this.oldCommanderTreeContainerExtent;
    CommanderTree.extent = %this.oldCommanderTreeExtent;
    CommanderTV.extent = %this.oldCommanderTVExtent;

    // positions
    CommanderTreeContainer.position = %this.oldCommanderTreeContainerPos;
    CommanderTree.position = %this.oldCommanderTreePos;
    CommanderTV.position = %this.oldCommanderTVPos;
  }
}

function TeamTV::moveHuds(%this, %val) {
  if (%val) {
    // Huds needed by the TV
    CommanderMapGui.remove(CommanderTV);
    TeamTV.add(CommanderTV);

    // Huds needed by the Selector
    CommanderMapGui.remove(CommanderTreeContainer);
    TeamTVSelHud.add(CommanderTreeContainer);
    CommanderTreeContainer.add(CommanderTree);

    // order
    TeamTV.bringToFront(CommanderTV);
    TeamTV.pushToBack(TeamTVObsHud);
    TeamTV.pushToBack(TeamTVSelHud);
  } else {
    // replace huds needed by tv
    TeamTV.remove(CommanderTV);
    CommanderMapGui.add(CommanderTV);

    // replace huds needed by selector
    TeamTVSelHud.remove(CommanderTreeContainer);
    CommanderMapGui.add(CommanderTreeContainer);
  }
}

function TeamTV::setPosition(%this, %val) {
  if (%val) {
    TeamTV.playGuiWidth = getWord(playGui.extent, 0);
    TeamTV.playGuiHeight = getWord(playGui.extent, 1);

    // setup teamtv hud
    TeamTV.position = "0 0";
    TeamTV.extent = TeamTV.playGuiWidth SPC TeamTV.playGuiHeight;
    CommanderTV.position = TeamTV.position;
    CommanderTV.extent = TeamTV.extent;

    // setup selector hud
    %selectorWidth = getWord(CommanderTreeContainer.extent, 0);
    %selectorHeight = TeamTV.defaultSelHeight;
    %selectorX = %this.playGuiWidth - %selectorWidth - 30;
    %selectorY = mfloor(%this.playGuiHeight / 2) - mfloor(%selectorHeight / 2);
    if ($hudposTeamTVSelHud $= "" || $hudposTeamTVSelHud $= "0 0")
      TeamTVSelHud.position = %selectorX SPC %selectorY;
    else
      TeamTVSelHud.position = $hudposTeamTVSelHud;
    TeamTVSelHud.extent = %selectorWidth SPC %selectorHeight;
    CommanderTreeContainer.extent = TeamTVSelHud.extent;
    CommanderTreeContainer.position = "0 0";

    // setup observer name hud
    %observerWidth = getWord(TeamTVObsHud.extent, 0);
    %observerHeight = getWord(TeamTVObsHud.extent, 1);
    %observerX = mfloor(%this.playGuiWidth / 2) - mfloor(%observerWidth / 2);
    %observerY = %this.playGuiHeight - %observerHeight - 70;
    if ($hudposTeamTVObsHud $= "" || $hudposTeamTVObsHud $= "0 0")
      TeamTVObsHud.position = %observerX SPC %observerY;
    else
      TeamTVObsHud.position = $hudposTeamTVObsHud;

    // setup order and make sure that they are seen
    TeamTV.pushToBack(TeamTVObsHud);
    TeamTV.pushToBack(TeamTVSelHud);
  }
}

//-----debugging function to reset hud to default position
function TeamTV::resetPosition() {
  echo("\c4Hud Positions reset!");
  $hudposTeamTVObsHud = "";
  $hudposTeamTVSelHud = "";
}

//-----change the selector look to our preferences
function TeamTV::changeSelector(%this, %val) {
  if (%val) {
    // save commandertree attributes
    if (!TeamTV.resetEngHud) {
      %this.oldHeaderHeight = %this.defaultHeaderHeight;
      %this.oldEntryHeight = %this.defaultEntryHeight;
      %this.oldBackdropBitmap = %this.defaultBackdropBitmap;
      %this.oldEntrySelectColor = %this.defaultEntrySelectColor;
      %this.oldEntryHilightColor = %this.defaultEntryHilightColor;
      %this.oldClientNoneText = %this.defaultClientNoneText;
    } else {
      %this.oldHeaderHeight = CommanderTree.headerHeight;
      %this.oldEntryHeight = CommanderTree.entryHeight;
      %this.oldBackdropBitmap = CommanderTree.backdropBitmapName;
      %this.oldEntrySelectColor = CommanderTree.entrySelectColor;
      %this.oldEntryHilightColor = CommanderTree.entryHilightColor;
      %this.oldClientNoneText = CommanderTree.clientNoneText;
    }

    CommanderTree.headerHeight = 0;
    CommanderTree.entryHeight = 20;
    CommanderTree.backdropBitmapName = "special/whiteAlpha0";
    CommanderTree.entrySelectColor = "0 0 0 0";
    CommanderTree.entryHilightColor = "44 168 219 100";
    CommanderTree.clientNoneText = "Observe Teammates";
  } else {
    CommanderTree.headerHeight = %this.oldHeaderHeight;
    CommanderTree.entryHeight = %this.oldEntryHeight;
    CommanderTree.backdropBitmapName = %this.oldBackdropBitmap;
    CommanderTree.entrySelectColor = %this.oldEntrySelectColor;
    CommanderTree.entryHilightColor = %this.oldEntryHilightColor;
    CommanderTree.clientNoneText = %this.oldClientNoneText;
  }
}

//-----open the camera for viewing
function TeamTV::openCamera(%this, %val) {
  if (%val) {
    schedule(1000, 0, "refreshMap");
    if (%this.isTarget()) {
      // show the camera
      if (CommanderTV.target == TeamTV.obsTarget)
        return;
      CommanderTV.open = 1;
      if (CommanderTV.attached)
        commandToServer('AttachCommanderCamera', -1);
      commandToServer('AttachCommanderCamera', %this.obsTarget);
      CommanderTV.setVisible(0);
      TeamTV.setVisible(1);
      TeamTVObsHudText.setValue("<just:center><spush><color:ffff00>Observing: <spop>" @ TeamTV.obsName);
    } else {
      // show static
      CommanderTV.open = 1;
      if (CommanderTV.attached)
        commandToServer('AttachCommanderCamera', -1);
      CommanderTV.target = -1;
      CommanderTV.setVisible(1);
      TeamTV.setVisible(1);
      TeamTVObsHudText.setValue("<just:center><spush><color:ff0000>Invalid Target<spop>");
    }
  } else {
    TeamTV.mapRefreshed = false;
    commandToServer('ResetControlObject');
    CommanderTV.open = 0;
    CommanderTV.setVisible(0);
    TeamTV.setVisible(0);
    TeamTVSelHud.setVisible(0);
    cursorOff();
  }
}

//-----start the camera
function TeamTV::open(%this, %val) {
  if (%val && !%this.isOpen) {
    // open the camera
    %this.isOpen = true;

    // we have to disable enghud temporarily because it uses some huds this script needs
    if ($pref::EngHud::on) {
      $pref::EngHUD::on = 0;
      EHReset();
      %this.resetEngHud = true;
    }

    // play sound for effect
    alxPlay(CommandMapActivateSound, 0, 0, 0);

    %this.editCategories(1);
    %this.editAttr(1);
    %this.changeSelector(1);
    %this.moveHuds(1);
    %this.setPosition(1);
    %this.openCamera(1);
    TeamTVActMap.push();
  } else if (!%val && %this.isOpen) {
    // close the camera
    %this.isOpen = false;

    // open enghud if it was open when camera was opened
    if (%this.resetEngHud) {
      $pref::EngHud::on = 1;
      EHReset();
      %this.resetEngHud = false;
    }

    // play sound for effect
    alxPlay(CommandMapDeactivateSound, 0, 0, 0);

    %this.changeSelector(0);
    %this.openCamera(0);
    %this.moveHuds(0);
    %this.editAttr(0);
    %this.editCategories(0);
    TeamTVActMap.pop();
  }
}

package TeamTVPkg {
//-----make it so clicking a name selects a new target to observe
  function GuiCommanderMap::onSelect(%this, %targetId, %nameTag, %typeTag, %select) {
    if (TeamTV.isOpen) {
      TeamTV.obsName = getTaggedString(%nameTag);
      TeamTV.targetToName[%targetId] = TeamTV.obsName;
      TeamTV.targetToNamePtr[TeamTV.targetToNamePtrCt] = %targetId;
      TeamTV.targetToNamePtrCt++;
      TeamTV.obsType = getTaggedString(%typeTag);
      TeamTV.obsTarget = %targetId;
      TeamTV.openCamera(1);
    } else {
      parent::onSelect(%this, %targetId, %nameTag, %typeTag, %select);
    }
  }

//-----open teamtv when playgui is displayed
  function PlayGui::onWake(%this) {
    if (!$TeamTVadded) {
      createTeamTVHud();
      PlayGUI.add(TeamTV);
      $TeamTVadded = true;
    }

    parent::onWake(%this);
  }

//-----close teamtv whenever playgui is hidden/closed
  function PlayGui::onSleep(%this) {
    TeamTV.open(0);

    parent::onSleep(%this);
  }

//-----add commands to bind to in options dialog
  function OptionsDlg::onWake(%this) {
   	if (!TeamTV.optionsBind) {
  		$RemapName[$RemapCount] = "Toggle Team TV Hud";
  		$RemapCmd[$RemapCount] = "TeamTVtoggle";
  		$RemapCount++;

  		$RemapName[$RemapCount] = "Toggle Selector Hud";
  		$RemapCmd[$RemapCount] = "TeamTVtoggleSelector";
  		$RemapCount++;

      TeamTV.optionsBind = true;
  	}

  	parent::onWake(%this);
  }

//-----we don't want the right click menu in the selector
  function CMContextPopup::display(%this) {
    if (!TeamTV.isOpen) {
      parent::display(%this);
    }
  }

//-----Hook into the commander map function so I can disable the button if needed
  function toggleCommanderMap( %val ) {
    if (!TeamTV.isOpen) {
      parent::toggleCommanderMap( %val ); // let's not open unless TV is closed
    }
	}

//-----don't allow user to open enghud unless camera is closed
  function toggleEngHud() {
    if (!TeamTV.isOpen)
      parent::toggleEngHud();
  }
};

$TeamTVadded = false;
activatePackage(TeamTVPkg);
addMessageCallBack('MsgIJoinedTeam', resetTeamTV);
